## mosml-ver-2.10.1.tar.gz

=== examples/Makefile ===
clean:
	cd calc; make clean
	cd cgi; make clean
	cd lexyacc; make clean
	cd manual; make clean
	cd mls; make clean
	cd parsercomb; make clean
	cd pretty; make clean
	cd webserver; make clean

=== src/Makefile ===
# Unix Makefile for Moscow ML

# To build the Moscow ML system on a new machine for the first time, 
#	(1) edit PREFIX etc. in file Makefile.inc
#	(2) execute `make world'

# To install it

#	(1) execute `make install'
#	(2) edit PREFIX in file mosml/tools/Makefile.stub

# ------------------------------------------------------------

include Makefile.inc

# Basis dynlibs
BASISDYNLIB=
ifeq ($(DYNLIBSUPPORT),true)
  BASISDYNLIB=intinf msocket munix
endif


# Build the entire system for the first time

world:
	cd config; $(MAKE) all
	cd runtime; $(MAKE) all
	cp runtime/camlrunm$(EXE) .
	cd mosmlyac; $(MAKE) all
	cd mosmllib; $(MAKE) all
	cd compiler; $(MAKE) all
	cd toolssrc; $(MAKE) all
	cd lex; $(MAKE) all
	cd launch; $(MAKE) all
	$(MAKE) basisdynlib

# Cross compilation to Win
cross_w32:
	cd config; $(MAKE) all
	cd runtime; $(MAKE) all
	cp runtime/camlrunm$(EXE) .
	$(MAKE) -C mosmlyac all
	$(MAKE) -C runtime clean
	$(MAKE) -C mosmlyac clean_obj
	$(MAKE) -C config UNAME_S=Cross_W32 w32
	$(MAKE) -C runtime UNAME_S=Cross_W32 camlrt.dll
	$(MAKE) -C mosmlyac UNAME_S=Cross_W32 all
	$(MAKE) -C mosmllib UNAME_S=Cross_W32 all
	$(MAKE) -C compiler UNAME_S=Cross_W32 w32
	$(MAKE) -C toolssrc UNAME_S=Cross_W32 all
	$(MAKE) -C lex UNAME_S=Cross_W32 all
	$(MAKE) -C launch.w32 UNAME_S=Cross_W32 all

	test -d $(DESTDIR)$(BINDIR) || mkdir -p $(DESTDIR)$(BINDIR)
	test -d $(DESTDIR)$(LIBDIR) || mkdir -p $(DESTDIR)$(LIBDIR)
	test -d $(DESTDIR)$(INCDIR) || mkdir -p $(DESTDIR)$(INCDIR)
	test -d $(DESTDIR)$(DOCDIR) || mkdir -p $(DESTDIR)$(DOCDIR)
	test -d $(DESTDIR)$(TOOLDIR) || mkdir -p $(DESTDIR)$(TOOLDIR)

	$(MAKE) -C runtime UNAME_S=Cross_W32 install_w32
	$(MAKE) -C mosmlyac UNAME_S=Cross_W32 install
	$(MAKE) -C mosmllib UNAME_S=Cross_W32 install
	$(MAKE) -C compiler UNAME_S=Cross_W32 install_w32
	$(MAKE) -C toolssrc UNAME_S=Cross_W32 install
	$(MAKE) -C lex UNAME_S=Cross_W32 install
	$(MAKE) -C launch.w32 UNAME_S=Cross_W32 install
	$(MAKE) -C doc install
#	$(MAKE) basisdynlib


uptodate:
	cd runtime; $(MAKE) all
	cp runtime/camlrunm$(EXE) .
	cd mosmlyac; $(MAKE) all
	cd mosmllib; $(MAKE) all
	cd compiler; $(MAKE) all
	cd toolssrc; $(MAKE) all
	cd lex; $(MAKE) all
	cd launch; $(MAKE) all

# Recompile all Mosml code from scratch
again:
	cd mosmllib; $(MAKE) clean all
	cd compiler; $(MAKE) clean all
	cd toolssrc; $(MAKE) clean all
	cd lex; $(MAKE) clean all


basisdynlib:
	for i in $(BASISDYNLIB); do \
	  (cd dynlibs/$$i; $(MAKE)) || exit $$?; \
	done


# Install the Mosml system
install:
	test -d $(DESTDIR)$(BINDIR) || mkdir -p $(DESTDIR)$(BINDIR)
	test -d $(DESTDIR)$(LIBDIR) || mkdir -p $(DESTDIR)$(LIBDIR)
	test -d $(DESTDIR)$(INCDIR) || mkdir -p $(DESTDIR)$(INCDIR)
	test -d $(DESTDIR)$(DOCDIR) || mkdir -p $(DESTDIR)$(DOCDIR)
	test -d $(DESTDIR)$(TOOLDIR) || mkdir -p $(DESTDIR)$(TOOLDIR)
	cd runtime; $(MAKE) install
#	cd config; $(MAKE) install
	cd launch; $(MAKE) all install
	cd mosmlyac; $(MAKE) install
	cd mosmllib; $(MAKE) install
	cd compiler; $(MAKE) install
	cd toolssrc; $(MAKE) install
	cd lex; $(MAKE) install
	cd doc; $(MAKE) install
	$(MAKE) basisdynlib_install

basisdynlib_install:
	for i in $(BASISDYNLIB); do \
	  (cd dynlibs/$$i; $(MAKE) install) || exit $$?; \
	done


# Remove all generated files
clean:
	cd config; $(MAKE) clean
	cd runtime; $(MAKE) clean
	cd launch; $(MAKE) clean
	cd mosmlyac; $(MAKE) clean
	cd mosmllib; $(MAKE) clean
	cd compiler; $(MAKE) clean
	cd toolssrc; $(MAKE) clean
	cd lex; $(MAKE) clean
	cd test; $(MAKE) clean
	cd mosmllib/test; $(MAKE) clean
	cd ../examples; $(MAKE) clean	
	cd dynlibs; $(MAKE) clean
	rm -f camlrunm$(EXE)
	cd doc; $(MAKE) clean

dynlibs:
	cd dynlibs; $(MAKE)

# Rebuild the dependencies in all Makefiles.
# You can't do this unless you have a compiled runtime system.
depend:
	cd mosmllib; $(MAKE) depend
	cd mosmlyac; $(MAKE) all
	cd compiler; $(MAKE) depend
	cd lex; $(MAKE) depend

=== examples/cgi/Makefile ===
# Unix Makefile stub for separate compilation with Moscow ML.  

# Edit this to point to the CGI binaries directory on your webserver:

WWWCGIBIN=/var/lib/httpd/cgi-bin/sestoft

MOSMLHOME=${HOME}/mosml
MOSMLTOOLS=camlrunm $(MOSMLHOME)/tools
MOSMLC=mosmlc -c
MOSMLL=mosmlc
MOSMLLEX=mosmllex
MOSMLYACC=mosmlyac

.SUFFIXES :
.SUFFIXES : .sig .sml .ui .uo

all: cgiex1 cgiex2

cgiex1: cgiex1.uo
	mosmlc -noheader -o cgiex1 cgiex1.uo 

cgiex2: cgiex2.uo
	mosmlc -noheader -o cgiex2 cgiex2.uo 

cgitest: cgitest.uo
	mosmlc -noheader -o cgitest cgitest.uo 

install:
	cat `which camlrunm` cgiex1 > ${WWWCGIBIN}/cgiex1
	chmod a+x ${WWWCGIBIN}/cgiex1
	cat `which camlrunm` cgiex2 > ${WWWCGIBIN}/cgiex2
	chmod a+x ${WWWCGIBIN}/cgiex2

uninstall:
	rm -f ${WWWCGIBIN}/cgiex1
	rm -f ${WWWCGIBIN}/cgiex2
	rm -f ${WWWCGIBIN}/cgitest

installcgitest:
	cat `which camlrunm` cgitest > ${WWWCGIBIN}/cgitest
	chmod a+x ${WWWCGIBIN}/cgitest

clean:
	rm -f *.ui
	rm -f *.uo
	rm -f cgiex1 cgiex2 cgitest
	rm -f Makefile.bak

.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

depend: 
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep >> Makefile

### DO NOT DELETE THIS LINE

=== examples/manual/Makefile ===
# Unix Makefile stub for separate compilation with Moscow ML.  

MOSMLHOME=${HOME}/mosml
MOSMLTOOLS=camlrunm $(MOSMLHOME)/tools
MOSMLC=mosmlc -c
MOSMLL=mosmlc
MOSMLLEX=mosmllex
MOSMLYACC=mosmlyac

.SUFFIXES :
.SUFFIXES : .sig .sml .ui .uo

all: Evaluate.uo Expr.uo Reduce.uo

clean:
	rm -f *.ui
	rm -f *.uo
	rm -f Makefile.bak

.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

depend: 
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep >> Makefile

### DO NOT DELETE THIS LINE
Evaluate.ui: Expr.uo 
Evaluate.uo: Evaluate.ui Expr.uo Reduce.ui 
Reduce.uo: Reduce.ui Expr.uo 
Reduce.ui: Expr.uo

=== examples/msp/Makefile ===
# Making and installing ML Server Pages version 1.2, for Moscow ML 2.10

# NB: Must set `SCRIPTCACHE' and `mosmlc' in mspcompile.sml prior to compilation.

CGI_DIR=/usr/lib/cgi-bin
SCRIPTCACHE=/var/cache/mspscripts

all: 
	mosmlc -standalone -o mspcompile mspcompile.sml

install: 
	cp mspcompile ${CGI_DIR}
	mkdir ${SCRIPTCACHE}
	chown www-data:www-data ${SCRIPTCACHE}

clean:
	rm -f *.ui *.uo
	rm -f mspcompile

=== examples/pretty/Makefile ===
all:
	mosml ppexpr.sml
clean:

=== examples/units/Makefile ===
# Unix Makefile stub for separate compilation with Moscow ML.  

MOSMLHOME=${HOME}/mosml
MOSMLTOOLS=camlrunm $(MOSMLHOME)/tools
MOSMLC=mosmlc -c -liberal
MOSMLL=mosmlc
MOSMLLEX=mosmllex
MOSMLYACC=mosmlyac

UNITS= -structure Expr Reduce -toplevel Evaluate Test

.SUFFIXES :
.SUFFIXES : .sig .sml .ui .uo
 
all: Evaluate.uo Expr.uo Reduce.uo Test.uo

clean:
	rm -f *.ui
	rm -f *.uo
	rm -f Makefile.bak

# these rules are only needed if UNITS is undefined or empty
.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

depend: 
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep $(UNITS) >> Makefile

### DO NOT DELETE THIS LINE
Expr.uo: Expr.sml 
	$(MOSMLC) -structure Expr.sml 
Reduce.ui: Reduce.sig Expr.uo 
	$(MOSMLC) -structure Expr.ui Reduce.sig 
Reduce.uo: Reduce.sml Reduce.ui Expr.uo 
	$(MOSMLC) -structure Expr.ui Reduce.sml 
Evaluate.ui: Evaluate.sig Reduce.ui 
	$(MOSMLC) -toplevel Reduce.ui Expr.ui Evaluate.sig 
Evaluate.uo: Evaluate.sml Evaluate.ui Reduce.ui 
	$(MOSMLC) -toplevel Reduce.ui Expr.ui \
    Evaluate.sml 
Test.uo: Test.sml Evaluate.ui 
	$(MOSMLC) -toplevel Evaluate.ui Reduce.ui Expr.ui Test.sml

=== examples/webserver/Makefile ===
# Unix Makefile stub for separate compilation with Moscow ML.  

MOSMLHOME=${HOME}/mosml
MOSMLTOOLS=camlrunm $(MOSMLHOME)/tools
MOSMLC=mosmlc -c
MOSMLL=mosmlc
MOSMLLEX=mosmllex
MOSMLYACC=mosmlyac

.SUFFIXES :
.SUFFIXES : .sig .sml .ui .uo

all: echoserver minimalserver mosmlserver

echoserver: echoserver.uo 
	mosmlc -o echoserver echoserver.uo 

minimalserver: minimalserver.uo 
	mosmlc -o minimalserver minimalserver.uo 

mosmlserver: mosmlserver.uo 
	mosmlc -o mosmlserver mosmlserver.uo 

clean:
	rm -f *.ui
	rm -f *.uo
	rm -f echoserver minimalserver mosmlserver
	rm -f Makefile.bak

.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

depend: 
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep >> Makefile

### DO NOT DELETE THIS LINE

=== src/compiler.cminusminus/Makefile ===
# Unix Makefile for Moscow ML compiler

COMPFLAGS=
# Option `-g' exports the exception table for mosmltop to read:
LINKFLAGS=-g -noheader

include ../Makefile.inc

COMP_OBJS = \
    Miscsys.uo Printexc.uo Filename.uo Fnlib.uo Sort.uo Stack.uo \
    Arg.uo Hasht.uo Memory.uo Config.uo Mixture.uo \
    Const.uo Prim.uo Instruct.uo \
    Lambda.uo Smlprim.uo Globals.uo Location.uo \
    Units.uo Types.uo Smlexc.uo Smlperv.uo Asynt.uo Asyntfn.uo \
    Parser.uo Lexer.uo Primdec.uo Infixst.uo Ovlres.uo \
    Synchk.uo Infixres.uo Elab.uo Tr_env.uo Pr_lam.uo \
    Match.uo Front.uo Back.uo Pr_zam.uo \
    Opcodes.uo Prim_opc.uo Buffcode.uo Labels.uo Code_dec.uo Reloc.uo \
    CmmAST.uo Wpp.uo CmmPrint.uo CmmEmitcode.uo Emit_phr.uo Sigmtch.uo Compiler.uo

C_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo \
    Lexing.uo Parsing.uo PP.uo

C_OBJS= \
    Mainc.uo

L_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo PP.uo

L_OBJS= \
    Miscsys.uo Printexc.uo Filename.uo \
    Fnlib.uo Arg.uo Hasht.uo Config.uo Mixture.uo Const.uo \
    Opcodes.uo Code_dec.uo \
    Predef.uo Prim_c.uo Symtable.uo Patch.uo Tr_const.uo \
    Link.uo Readword.uo Mainl.uo

T_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo \
    Substring.uo Path.uo Time.uo OS.uo FileSys.uo \
    Lexing.uo Parsing.uo PP.uo

T_OBJS= \
    Predef.uo Prim_c.uo Symtable.uo Patch.uo Tr_const.uo \
    Rtvals.uo Load_phr.uo Exec_phr.uo Smltop.uo Maint.uo

all: mosmlcmmc 

dos: mosmlcmp.dos mosmllnk.dos mosmltop.dos

w32: mosmlcmp.w32 mosmllnk.w32 mosmltop.w32
	echo 'Remember to set the CPP for win32 in Makefile.inc'

mosmlcmmc: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmlcmmc Mainc.uo

mosmlcmp.dos: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmlcmp Mainc.uo

mosmlcmp.w32: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmlcmp.w32 Mainc.uo

Opcodes.sml: $(CAMLRT)/instruct.h
	$(PERL) $(MOSMLTOOLS)/mksmlopc $(CAMLRT)/instruct.h > Opcodes.sml

Parser.sml Parser.sig: Parser.grm
	$(MOSMLYACC) Parser.grm

mosmllnk: $(L_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmllnk Mainl.uo

mosmllnk.dos: $(L_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmllnk Mainl.uo

mosmllnk.w32: $(L_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmllnk.w32 Mainl.uo

Predef.sml : $(CAMLRT)/globals.h 
	$(PERL) $(MOSMLTOOLS)/mksmlpre $(CAMLRT)/globals.h > Predef.sml

Prim_c.sml : $(CAMLRT)/primitives
	$(PERL) $(MOSMLTOOLS)/mksmlprc $(CAMLRT)/primitives > Prim_c.sml

mosmltop: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmltop Maint.uo 

mosmltop.dos: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmltop Maint.uo

mosmltop.w32: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmltop.w32 Maint.uo

clean:
	rm -f mosmlcmmc
	rm -f mosmllnk
	rm -f mosmltop
	rm -f *.ui
	rm -f *.uo
	rm -f Opcodes.sml
	rm -f Parser.sml
	rm -f Parser.sig
	rm -f Parser.output
	rm -f Lexer.sml
	rm -f Config.sml
	rm -f Filename.sml
	rm -f Predef.sml
	rm -f Prim_c.sml
	rm -f Makefile.bak

install:
	${INSTALL_DATA} mosmlcmmc $(LIBDIR)
	${INSTALL_DATA} mosmlc-- $(BINDIR)

promote:
	test -f ../mosmlcmmc.orig || cp ../mosmlcmmc ../mosmlcmmc.orig
	#test -f ../mosmllnk.orig || cp ../mosmllnk ../mosmllnk.orig
	#test -f ../mosmllex.orig || cp ../mosmllex ../mosmllex.orig
	#$(MOSMLL) $(LINKFLAGS) -o mosmlcmp $(C_LIBOBJS) $(COMP_OBJS) $(C_OBJS)
	#$(MOSMLL) $(LINKFLAGS) -o mosmllnk $(L_LIBOBJS) $(L_OBJS) 
	#$(MOSMLL) $(LINKFLAGS) -o mosmltop $(T_LIBOBJS) $(T_OBJS) 
	#test -f mosmllnk && cp mosmllnk ../mosmllnk
	test -f mosmlcmmc && cp mosmlcmmc ../mosmlcmmc
	#test -f ../lex/mosmllex && cp ../lex/mosmllex ../mosmllex

revert:
	test -f ../mosmlcmmc.orig && (rm ../mosmlcmp;mv ../mosmlcmp.orig ../mosmlcmp)
	#test -f ../mosmllnk.orig && (rm ../mosmllnk;mv ../mosmllnk.orig ../mosmllnk)
	#test -f ../mosmllex.orig && (rm ../mosmllex;mv ../mosmllex.orig ../mosmllex)
	#test -f ../mosmllib/Callback.sml.orig && (rm ../mosmllib/Callback.sml;mv ../mosmllib/Callback.sml.orig ../mosmllib/Callback.sml)

depend: Filename.sml Config.sml Opcodes.sml Parser.sml Parser.sig Lexer.sml \
    Predef.sml Prim_c.sml
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLCUT) < Makefile.bak > Makefile
	$(MOSMLDEP) >> Makefile

regress:
	echo "building current lib"
	cd ../mosmllib; make -s current
	echo "testing current lib"
	cd ../mosmllib/test; make -s current  || echo "results differ"
	echo "testing current test"
	cd ../test; make -s current || echo "results differ"
	echo "testing current compiler test"
	cd test; make -s current || echo "results differ"

### DO NOT DELETE THIS LINE
Wpp.uo: Wpp.ui 
CmmEmitcode.uo: Mixture.ui Instruct.uo Prim.uo CmmAST.uo Pr_zam.uo Fnlib.ui \
    Const.uo 
CmmBack.uo: Sort.ui Pr_lam.ui Stack.ui CmmAST.uo Lambda.uo 
CmmPrint.uo: CmmPrint.ui Wpp.ui CmmAST.uo 
CmmPrint.ui: Wpp.ui CmmAST.uo 
Predef.uo: Const.uo 
Lexer.uo: Lexer.ui Parser.ui Const.uo Fnlib.ui Config.uo Stack.ui \
    Mixture.ui Hasht.ui Memory.uo 
Parser.ui: Asynt.uo Const.uo 
Parser.uo: Parser.ui Asynt.uo Const.uo Fnlib.ui Config.uo Types.ui \
    Asyntfn.ui Globals.uo Location.ui Mixture.ui 
Config.uo: Fnlib.ui 
Filename.uo: Filename.ui 
Units.uo: Units.ui Const.uo Fnlib.ui Config.uo Globals.uo Location.ui \
    Mixture.ui Hasht.ui Filename.ui 
Units.ui: Const.uo Fnlib.ui Globals.uo Location.ui Mixture.ui Hasht.ui 
Types.uo: Types.ui Const.uo Fnlib.ui Config.uo Globals.uo Smlprim.uo \
    Location.ui Mixture.ui Units.ui Hasht.ui 
Types.ui: Const.uo Fnlib.ui Globals.uo Smlprim.uo Location.ui Mixture.ui \
    Units.ui 
Tr_env.uo: Tr_env.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Types.ui Asyntfn.ui \
    Globals.uo Mixture.ui Units.ui Hasht.ui Lambda.uo 
Tr_env.ui: Asynt.uo Const.uo Mixture.ui Lambda.uo 
Tr_const.uo: Const.uo Symtable.ui 
Synchk.uo: Synchk.ui Asynt.uo Const.uo Fnlib.ui Asyntfn.ui Globals.uo \
    Location.ui Mixture.ui Units.ui 
Synchk.ui: Asynt.uo 
Symtable.uo: Symtable.ui Const.uo Fnlib.ui Config.uo Predef.uo Prim_c.uo \
    Mixture.ui Hasht.ui Miscsys.ui 
Symtable.ui: Const.uo 
Stack.uo: Stack.ui 
Sort.uo: Sort.ui 
Smltop.uo: Smltop.ui Compiler.ui Const.uo Fnlib.ui Patch.uo Emit_phr.uo \
    Rtvals.ui Config.uo Code_dec.uo Lexer.ui Types.ui Globals.uo Smlprim.uo \
    Smlexc.uo Smlperv.ui Opcodes.uo Location.ui Symtable.ui Emitcode.ui \
    Mixture.ui Units.ui Load_phr.ui Hasht.ui Miscsys.ui Memory.uo \
    Filename.ui Exec_phr.ui 
Smlprim.uo: Const.uo Prim.uo 
Smlperv.uo: Smlperv.ui Const.uo Fnlib.ui Prim.uo Types.ui Globals.uo \
    Smlprim.uo Smlexc.uo Units.ui Hasht.ui 
Smlexc.uo: Const.uo Fnlib.ui Config.uo Types.ui Mixture.ui 
Sigmtch.uo: Sigmtch.ui Front.ui Const.uo Back.ui Fnlib.ui Emit_phr.uo \
    Prim.uo Types.ui Globals.uo Mixture.ui Units.ui Hasht.ui Lambda.uo 
Sigmtch.ui: Units.ui 
Rtvals.uo: Rtvals.ui Const.uo Fnlib.ui Config.uo Types.ui Globals.uo \
    Smlexc.uo Symtable.ui Mixture.ui Units.ui Miscsys.ui Memory.uo 
Rtvals.ui: Const.uo Types.ui Globals.uo 
Reloc.uo: Const.uo Buffcode.uo Code_dec.uo Hasht.ui 
Printexc.uo: Printexc.ui 
Primdec.uo: Const.uo Fnlib.ui Prim.uo Smlprim.uo 
Prim_opc.uo: Fnlib.ui Prim.uo Opcodes.uo 
Prim.uo: Const.uo 
Pr_zam.uo: Asynt.uo Const.uo Fnlib.ui Config.uo Pr_lam.ui Instruct.uo \
    Mixture.ui 
Pr_lam.uo: Pr_lam.ui Asynt.uo Const.uo Prim.uo Mixture.ui Lambda.uo 
Pr_lam.ui: Prim.uo Lambda.uo 
Patch.uo: Code_dec.uo Symtable.ui 
Ovlres.uo: Ovlres.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Types.ui Globals.uo \
    Smlprim.uo Location.ui Mixture.ui Units.ui 
Ovlres.ui: Asynt.uo 
Mixture.uo: Mixture.ui Fnlib.ui Config.uo Hasht.ui Miscsys.ui Filename.ui 
Mixture.ui: Hasht.ui 
Miscsys.uo: Miscsys.ui 
Match.uo: Match.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Asyntfn.ui Tr_env.ui \
    Location.ui Mixture.ui Hasht.ui Lambda.uo 
Match.ui: Asynt.uo Tr_env.ui Location.ui Lambda.uo 
Maint.uo: Maint.ui Compiler.ui Fnlib.ui Rtvals.ui Config.uo Types.ui Arg.ui \
    Printexc.ui Smlperv.ui Location.ui Smltop.ui Mixture.ui Units.ui \
    Miscsys.ui Memory.uo Exec_phr.ui 
Mainl.uo: Fnlib.ui Config.uo Arg.ui Printexc.ui Link.ui Symtable.ui \
    Readword.uo Mixture.ui Miscsys.ui Filename.ui 
Mainc.uo: Mainc.ui Compiler.ui Fnlib.ui Config.uo Lexer.ui Types.ui Arg.ui \
    Printexc.ui Smlperv.ui Location.ui Mixture.ui Units.ui Miscsys.ui \
    Filename.ui 
Location.uo: Location.ui Fnlib.ui Config.uo Mixture.ui 
Load_phr.uo: Load_phr.ui Const.uo Reloc.uo Fnlib.ui Buffcode.uo Patch.uo \
    Rtvals.ui Types.ui Opcodes.uo Symtable.ui Labels.uo Emitcode.ui \
    Instruct.uo Tr_const.uo Mixture.ui Memory.uo 
Load_phr.ui: Instruct.uo 
Link.uo: Link.ui Const.uo Fnlib.ui Patch.uo Config.uo Code_dec.uo \
    Opcodes.uo Symtable.ui Tr_const.uo Mixture.ui Hasht.ui Miscsys.ui \
    Filename.ui 
Lexer.ui: Parser.ui 
Lambda.uo: Const.uo Prim.uo Instruct.uo 
Labels.uo: Fnlib.ui Buffcode.uo Instruct.uo 
Instruct.uo: Const.uo Config.uo Prim.uo 
Infixst.uo: Infixst.ui Asynt.uo Const.uo Fnlib.ui Globals.uo Location.ui \
    Mixture.ui 
Infixst.ui: Asynt.uo Fnlib.ui Globals.uo Location.ui Mixture.ui 
Infixres.uo: Infixres.ui Asynt.uo Primdec.uo Const.uo Fnlib.ui Infixst.ui \
    Types.ui Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo Location.ui \
    Mixture.ui Units.ui 
Infixres.ui: Asynt.uo Globals.uo 
Hasht.uo: Hasht.ui 
Globals.uo: Const.uo Fnlib.ui Smlprim.uo Mixture.ui 
Front.uo: Front.ui Asynt.uo Const.uo Fnlib.ui Config.uo Prim.uo Types.ui \
    Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo Tr_env.ui Location.ui \
    Match.ui Mixture.ui Units.ui Lambda.uo 
Front.ui: Asynt.uo Globals.uo Smlprim.uo Tr_env.ui Lambda.uo 
Fnlib.uo: Fnlib.ui 
Exec_phr.uo: Exec_phr.ui Asynt.uo Front.ui Compiler.ui Const.uo Back.ui \
    Fnlib.ui Pr_zam.uo Infixst.ui Elab.ui Rtvals.ui Types.ui Ovlres.ui \
    Globals.uo Tr_env.ui Symtable.ui Mixture.ui Units.ui Load_phr.ui \
    Infixres.ui Miscsys.ui 
Exec_phr.ui: Asynt.uo 
Emitcode.uo: Emitcode.ui Const.uo Reloc.uo Fnlib.ui Buffcode.uo Config.uo \
    Prim.uo Opcodes.uo Labels.uo Instruct.uo Mixture.ui Prim_opc.uo 
Emitcode.ui: Instruct.uo 
Emit_phr.uo: CmmPrint.ui Code_dec.uo Wpp.ui Instruct.uo CmmAST.uo \
    CmmEmitcode.uo 
Elab.uo: Elab.ui Asynt.uo Primdec.uo Sort.ui Synchk.ui Const.uo Fnlib.ui \
    Config.uo Types.ui Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo \
    Location.ui Mixture.ui Units.ui 
Elab.ui: Asynt.uo Globals.uo 
Const.uo: Fnlib.ui Config.uo Mixture.ui 
Compiler.uo: Compiler.ui Asynt.uo Front.ui Parser.ui Const.uo Back.ui \
    Fnlib.ui Pr_zam.uo Elab.ui Emit_phr.uo Lexer.ui Config.uo Sigmtch.ui \
    Types.ui Ovlres.ui Globals.uo Smlperv.ui Tr_env.ui Location.ui \
    Mixture.ui Units.ui Infixres.ui Hasht.ui 
Compiler.ui: Asynt.uo Globals.uo Mixture.ui 
Code_dec.uo: Const.uo Mixture.ui Hasht.ui 
Buffcode.uo: Fnlib.ui Config.uo Opcodes.uo Mixture.ui 
Back.uo: Back.ui Sort.ui Const.uo Fnlib.ui Prim.uo Instruct.uo Stack.ui \
    Mixture.ui Lambda.uo 
Back.ui: Instruct.uo Lambda.uo 
Asyntfn.uo: Asyntfn.ui Asynt.uo Const.uo Fnlib.ui Types.ui Globals.uo \
    Location.ui Mixture.ui 
Asyntfn.ui: Asynt.uo Const.uo Fnlib.ui Types.ui Globals.uo Location.ui \
    Mixture.ui 
Arg.uo: Arg.ui Fnlib.ui Miscsys.ui 
Asynt.uo: Const.uo Fnlib.ui Types.ui Globals.uo Location.ui Mixture.ui \
    Lambda.uo

=== src/compiler/Makefile ===
# Unix Makefile for Moscow ML compiler

COMPFLAGS=
# Option `-g' exports the exception table for mosmltop to read:
LINKFLAGS=-g -noheader

include ../Makefile.inc

COMP_OBJS = \
    Miscsys.uo Printexc.uo Filename.uo Fnlib.uo Sort.uo Stack.uo \
    Arg.uo Hasht.uo Memory.uo Config.uo Mixture.uo \
    Const.uo Prim.uo Instruct.uo \
    Lambda.uo Smlprim.uo Globals.uo Location.uo \
    Units.uo Types.uo Smlexc.uo Smlperv.uo Asynt.uo Asyntfn.uo \
    Parser.uo Lexer.uo Primdec.uo Infixst.uo Ovlres.uo \
    Synchk.uo Infixres.uo Elab.uo Tr_env.uo Pr_lam.uo \
    Match.uo Front.uo Back.uo Pr_zam.uo \
    Opcodes.uo Prim_opc.uo Buffcode.uo Labels.uo Code_dec.uo Reloc.uo \
    Emitcode.uo Emit_phr.uo Sigmtch.uo Compiler.uo

C_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo \
    Lexing.uo Parsing.uo PP.uo

C_OBJS= \
    Mainc.uo

L_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo PP.uo

L_OBJS= \
    Miscsys.uo Printexc.uo Filename.uo \
    Fnlib.uo Arg.uo Hasht.uo Config.uo Mixture.uo Const.uo \
    Opcodes.uo Code_dec.uo \
    Predef.uo Prim_c.uo Symtable.uo Patch.uo Tr_const.uo \
    Link.uo Readword.uo Mainl.uo

T_LIBOBJS= \
    List.uo Strbase.uo Char.uo String.uo BasicIO.uo TextIO.uo \
    Vector.uo Array.uo Misc.uo \
    StringCvt.uo Word.uo Word8.uo Word8Vector.uo CharVector.uo \
    Word8Array.uo CharArray.uo Obj.uo Nonstdio.uo \
    Substring.uo Path.uo Time.uo OS.uo FileSys.uo \
    Lexing.uo Parsing.uo PP.uo

T_OBJS= \
    Predef.uo Prim_c.uo Symtable.uo Patch.uo Tr_const.uo \
    Rtvals.uo Load_phr.uo Exec_phr.uo Smltop.uo Maint.uo

all: mosmlcmp mosmllnk mosmltop

dos: mosmlcmp.dos mosmllnk.dos mosmltop.dos

w32: mosmlcmp.w32 mosmllnk.w32 mosmltop.w32
	echo 'Remember to set the CPP for win32 in Makefile.inc'

mosmlcmp: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmlcmp Mainc.uo

mosmlcmp.dos: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmlcmp Mainc.uo

mosmlcmp.w32: $(COMP_OBJS) $(C_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmlcmp.w32 Mainc.uo

Opcodes.sml: $(CAMLRT)/instruct.h
	$(PERL) $(MOSMLTOOLS)/mksmlopc $(CAMLRT)/instruct.h > Opcodes.sml

Parser.sml Parser.sig: Parser.grm
	$(MOSMLYACC) Parser.grm

mosmllnk: $(L_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmllnk Mainl.uo

mosmllnk.dos: $(L_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmllnk Mainl.uo

mosmllnk.w32: $(L_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmllnk.w32 Mainl.uo

Predef.sml : $(CAMLRT)/globals.h 
	$(PERL) $(MOSMLTOOLS)/mksmlpre $(CAMLRT)/globals.h > Predef.sml

Prim_c.sml : $(CAMLRT)/primitives
	$(PERL) $(MOSMLTOOLS)/mksmlprc $(CAMLRT)/primitives > Prim_c.sml

mosmltop: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmltop Maint.uo 

mosmltop.dos: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLLDOS) $(LINKFLAGS) -o mosmltop Maint.uo

mosmltop.w32: $(COMP_OBJS) $(T_OBJS)
	$(MOSMLL) $(LINKFLAGS) -o mosmltop.w32 Maint.uo

clean:
	rm -f mosmlcmp
	rm -f mosmllnk
	rm -f mosmltop
	rm -f *.ui
	rm -f *.uo
	rm -f Opcodes.sml
	rm -f Parser.sml
	rm -f Parser.sig
	rm -f Parser.output
	rm -f Lexer.sml
	rm -f Config.sml
	rm -f Filename.sml
	rm -f Predef.sml
	rm -f Prim_c.sml
	rm -f Makefile.bak

install:
	${INSTALL_DATA} mosmlcmp $(DESTDIR)$(LIBDIR)
	${INSTALL_DATA} mosmllnk $(DESTDIR)$(LIBDIR)
	${INSTALL_DATA} mosmltop $(DESTDIR)$(LIBDIR)


install_w32:
	${INSTALL_DATA} mosmlcmp.w32 $(DESTDIR)$(LIBDIR)/mosmlcmp
	${INSTALL_DATA} mosmllnk.w32 $(DESTDIR)$(LIBDIR)/mosmllnk
	${INSTALL_DATA} mosmltop.w32 $(DESTDIR)$(LIBDIR)/mosmltop



promote:
	test -f ../mosmlcmp.orig || cp ../mosmlcmp ../mosmlcmp.orig
	test -f ../mosmllnk.orig || cp ../mosmllnk ../mosmllnk.orig
	test -f ../mosmllex.orig || cp ../mosmllex ../mosmllex.orig
	#$(MOSMLL) $(LINKFLAGS) -o mosmlcmp $(C_LIBOBJS) $(COMP_OBJS) $(C_OBJS)
	#$(MOSMLL) $(LINKFLAGS) -o mosmllnk $(L_LIBOBJS) $(L_OBJS) 
	#$(MOSMLL) $(LINKFLAGS) -o mosmltop $(T_LIBOBJS) $(T_OBJS) 
	test -f mosmllnk && cp mosmllnk ../mosmllnk
	test -f mosmlcmp && cp mosmlcmp ../mosmlcmp
	test -f ../lex/mosmllex && cp ../lex/mosmllex ../mosmllex

revert:
	test -f ../mosmlcmp.orig && (rm ../mosmlcmp;mv ../mosmlcmp.orig ../mosmlcmp)
	test -f ../mosmllnk.orig && (rm ../mosmllnk;mv ../mosmllnk.orig ../mosmllnk)
	test -f ../mosmllex.orig && (rm ../mosmllex;mv ../mosmllex.orig ../mosmllex)
	test -f ../mosmllib/Callback.sml.orig && (rm ../mosmllib/Callback.sml;mv ../mosmllib/Callback.sml.orig ../mosmllib/Callback.sml)

depend: Filename.sml Config.sml Opcodes.sml Parser.sml Parser.sig Lexer.sml \
    Predef.sml Prim_c.sml
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLCUT) < Makefile.bak > Makefile
	$(MOSMLDEP) >> Makefile

regress:
	echo "building current lib"
	cd ../mosmllib; make -s current
	echo "testing current lib"
	cd ../mosmllib/test; make -s current  || echo "results differ"
	echo "testing current test"
	cd ../test; make -s current || echo "results differ"
	echo "testing current compiler test"
	cd test; make -s current || echo "results differ"

### DO NOT DELETE THIS LINE
Predef.uo: Const.uo 
Lexer.uo: Lexer.ui Parser.ui Const.uo Fnlib.ui Config.uo Stack.ui \
    Mixture.ui Hasht.ui Memory.uo 
Parser.ui: Asynt.uo Const.uo 
Parser.uo: Parser.ui Asynt.uo Const.uo Fnlib.ui Config.uo Types.ui \
    Asyntfn.ui Globals.uo Location.ui Mixture.ui 
Config.uo: Fnlib.ui 
Filename.uo: Filename.ui 
Units.uo: Units.ui Const.uo Fnlib.ui Config.uo Globals.uo Location.ui \
    Mixture.ui Hasht.ui Filename.ui 
Units.ui: Const.uo Fnlib.ui Globals.uo Location.ui Mixture.ui Hasht.ui 
Types.uo: Types.ui Const.uo Fnlib.ui Config.uo Globals.uo Smlprim.uo \
    Location.ui Mixture.ui Units.ui Hasht.ui 
Types.ui: Const.uo Fnlib.ui Globals.uo Smlprim.uo Location.ui Mixture.ui \
    Units.ui 
Tr_env.uo: Tr_env.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Types.ui Asyntfn.ui \
    Globals.uo Mixture.ui Units.ui Hasht.ui Lambda.uo 
Tr_env.ui: Asynt.uo Const.uo Mixture.ui Lambda.uo 
Tr_const.uo: Const.uo Symtable.ui 
Synchk.uo: Synchk.ui Asynt.uo Const.uo Fnlib.ui Asyntfn.ui Globals.uo \
    Location.ui Mixture.ui Units.ui 
Synchk.ui: Asynt.uo 
Symtable.uo: Symtable.ui Const.uo Fnlib.ui Config.uo Predef.uo Prim_c.uo \
    Mixture.ui Hasht.ui Miscsys.ui 
Symtable.ui: Const.uo 
Stack.uo: Stack.ui 
Sort.uo: Sort.ui 
Smltop.uo: Smltop.ui Compiler.ui Const.uo Fnlib.ui Patch.uo Emit_phr.uo \
    Rtvals.ui Config.uo Code_dec.uo Lexer.ui Types.ui Globals.uo Smlprim.uo \
    Smlexc.uo Smlperv.ui Opcodes.uo Location.ui Symtable.ui Emitcode.ui \
    Mixture.ui Units.ui Load_phr.ui Hasht.ui Miscsys.ui Memory.uo \
    Filename.ui Exec_phr.ui 
Smlprim.uo: Const.uo Prim.uo 
Smlperv.uo: Smlperv.ui Const.uo Fnlib.ui Prim.uo Types.ui Globals.uo \
    Smlprim.uo Smlexc.uo Units.ui Hasht.ui 
Smlexc.uo: Const.uo Fnlib.ui Config.uo Types.ui Mixture.ui 
Sigmtch.uo: Sigmtch.ui Front.ui Const.uo Back.ui Fnlib.ui Emit_phr.uo \
    Prim.uo Types.ui Globals.uo Mixture.ui Units.ui Hasht.ui Lambda.uo 
Sigmtch.ui: Units.ui 
Rtvals.uo: Rtvals.ui Const.uo Fnlib.ui Config.uo Types.ui Globals.uo \
    Smlexc.uo Symtable.ui Mixture.ui Units.ui Miscsys.ui Memory.uo 
Rtvals.ui: Const.uo Types.ui Globals.uo 
Reloc.uo: Const.uo Buffcode.uo Code_dec.uo Hasht.ui 
Printexc.uo: Printexc.ui 
Primdec.uo: Const.uo Fnlib.ui Prim.uo Smlprim.uo 
Prim_opc.uo: Fnlib.ui Prim.uo Opcodes.uo 
Prim.uo: Const.uo 
Pr_zam.uo: Asynt.uo Const.uo Fnlib.ui Config.uo Pr_lam.ui Instruct.uo \
    Mixture.ui 
Pr_lam.uo: Pr_lam.ui Asynt.uo Const.uo Prim.uo Mixture.ui Lambda.uo 
Pr_lam.ui: Prim.uo Lambda.uo 
Patch.uo: Code_dec.uo Symtable.ui 
Ovlres.uo: Ovlres.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Types.ui Globals.uo \
    Smlprim.uo Location.ui Mixture.ui Units.ui 
Ovlres.ui: Asynt.uo 
Mixture.uo: Mixture.ui Fnlib.ui Config.uo Hasht.ui Miscsys.ui Filename.ui 
Mixture.ui: Hasht.ui 
Miscsys.uo: Miscsys.ui 
Match.uo: Match.ui Asynt.uo Const.uo Fnlib.ui Prim.uo Asyntfn.ui Tr_env.ui \
    Location.ui Mixture.ui Hasht.ui Lambda.uo 
Match.ui: Asynt.uo Tr_env.ui Location.ui Lambda.uo 
Maint.uo: Maint.ui Compiler.ui Fnlib.ui Rtvals.ui Config.uo Types.ui Arg.ui \
    Printexc.ui Smlperv.ui Location.ui Smltop.ui Mixture.ui Units.ui \
    Miscsys.ui Memory.uo Exec_phr.ui 
Mainl.uo: Fnlib.ui Config.uo Arg.ui Printexc.ui Link.ui Symtable.ui \
    Readword.uo Mixture.ui Miscsys.ui Filename.ui 
Mainc.uo: Mainc.ui Compiler.ui Fnlib.ui Config.uo Lexer.ui Types.ui Arg.ui \
    Printexc.ui Smlperv.ui Location.ui Mixture.ui Units.ui Miscsys.ui \
    Filename.ui 
Location.uo: Location.ui Fnlib.ui Config.uo Mixture.ui 
Load_phr.uo: Load_phr.ui Const.uo Reloc.uo Fnlib.ui Buffcode.uo Patch.uo \
    Rtvals.ui Types.ui Opcodes.uo Symtable.ui Labels.uo Emitcode.ui \
    Instruct.uo Tr_const.uo Mixture.ui Memory.uo 
Load_phr.ui: Instruct.uo 
Link.uo: Link.ui Const.uo Fnlib.ui Patch.uo Config.uo Code_dec.uo \
    Opcodes.uo Symtable.ui Tr_const.uo Mixture.ui Hasht.ui Miscsys.ui \
    Filename.ui 
Lexer.ui: Parser.ui 
Lambda.uo: Const.uo Prim.uo Instruct.uo 
Labels.uo: Fnlib.ui Buffcode.uo Instruct.uo 
Instruct.uo: Const.uo Config.uo Prim.uo 
Infixst.uo: Infixst.ui Asynt.uo Const.uo Fnlib.ui Globals.uo Location.ui \
    Mixture.ui 
Infixst.ui: Asynt.uo Fnlib.ui Globals.uo Location.ui Mixture.ui 
Infixres.uo: Infixres.ui Asynt.uo Primdec.uo Const.uo Fnlib.ui Infixst.ui \
    Types.ui Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo Location.ui \
    Mixture.ui Units.ui 
Infixres.ui: Asynt.uo Globals.uo 
Hasht.uo: Hasht.ui 
Globals.uo: Const.uo Fnlib.ui Smlprim.uo Mixture.ui 
Front.uo: Front.ui Asynt.uo Const.uo Fnlib.ui Config.uo Prim.uo Types.ui \
    Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo Tr_env.ui Location.ui \
    Match.ui Mixture.ui Units.ui Lambda.uo 
Front.ui: Asynt.uo Globals.uo Smlprim.uo Tr_env.ui Lambda.uo 
Fnlib.uo: Fnlib.ui 
Exec_phr.uo: Exec_phr.ui Asynt.uo Front.ui Compiler.ui Const.uo Back.ui \
    Fnlib.ui Pr_zam.uo Infixst.ui Elab.ui Rtvals.ui Types.ui Ovlres.ui \
    Globals.uo Tr_env.ui Symtable.ui Mixture.ui Units.ui Load_phr.ui \
    Infixres.ui Miscsys.ui 
Exec_phr.ui: Asynt.uo 
Emitcode.uo: Emitcode.ui Const.uo Reloc.uo Fnlib.ui Buffcode.uo Config.uo \
    Prim.uo Opcodes.uo Labels.uo Instruct.uo Mixture.ui Prim_opc.uo 
Emitcode.ui: Instruct.uo 
Emit_phr.uo: Const.uo Reloc.uo Buffcode.uo Code_dec.uo Labels.uo \
    Emitcode.ui Instruct.uo Mixture.ui 
Elab.uo: Elab.ui Asynt.uo Primdec.uo Sort.ui Synchk.ui Const.uo Fnlib.ui \
    Config.uo Types.ui Asyntfn.ui Globals.uo Smlprim.uo Smlexc.uo \
    Location.ui Mixture.ui Units.ui 
Elab.ui: Asynt.uo Globals.uo 
Const.uo: Fnlib.ui Config.uo Mixture.ui 
Compiler.uo: Compiler.ui Asynt.uo Front.ui Parser.ui Const.uo Back.ui \
    Fnlib.ui Pr_zam.uo Elab.ui Emit_phr.uo Lexer.ui Config.uo Sigmtch.ui \
    Types.ui Ovlres.ui Globals.uo Smlperv.ui Tr_env.ui Location.ui \
    Mixture.ui Units.ui Infixres.ui Hasht.ui 
Compiler.ui: Asynt.uo Globals.uo Mixture.ui 
Code_dec.uo: Const.uo Mixture.ui Hasht.ui 
Buffcode.uo: Fnlib.ui Config.uo Opcodes.uo Mixture.ui 
Back.uo: Back.ui Sort.ui Const.uo Fnlib.ui Prim.uo Instruct.uo Stack.ui \
    Mixture.ui Lambda.uo 
Back.ui: Instruct.uo Lambda.uo 
Asyntfn.uo: Asyntfn.ui Asynt.uo Const.uo Fnlib.ui Types.ui Globals.uo \
    Location.ui Mixture.ui 
Asyntfn.ui: Asynt.uo Const.uo Fnlib.ui Types.ui Globals.uo Location.ui \
    Mixture.ui 
Arg.uo: Arg.ui Fnlib.ui Miscsys.ui 
Asynt.uo: Const.uo Fnlib.ui Types.ui Globals.uo Location.ui Mixture.ui \
    Lambda.uo

=== src/config/Makefile ===
include ../Makefile.inc

all: defs.h runtime

defs.h:
	@echo "#define VERSION $(VERSION)" > defs.h
	@echo "#define VERSION_S \"$(VERSION)\"" >> defs.h
	@echo "#define DYNLIBSUPPORT $(DYNLIBSUPPORT)" >> defs.h 
	@echo "#define DYNLIBSUPPORT_S \"$(DYNLIBSUPPORT)\"" >> defs.h 

.PHONY: runtime w32
runtime:
	sh autoconf $(CC)
	$(INSTALL_DATA) m.h s.h ../runtime
w32:
	$(INSTALL_DATA) ../config.w32/m.h ../runtime
	$(INSTALL_DATA) ../config.w32/s.h ../runtime


clean scratch:
	rm -f m.h s.h defs.h
	cd auto-aux; rm -f *.o a.out

=== src/convert/Makefile ===
# Unix Makefile for convert


MOSMLHOME=../..
MOSMLTOOLS=../camlrunm $(MOSMLHOME)/tools

MOSMLC=$(MOSMLHOME)/bin/mosmlc -c
MOSMLL=$(MOSMLHOME)/bin/mosmlc
MOSMLLEX=$(MOSMLHOME)/bin/mosmllex
MOSMLYACC=$(MOSMLHOME)/bin/mosmlyac

CONVOBJS = Scanner.uo Parser.uo Convert.uo
GENPMOBJS = Deplex.uo Deppars.uo GenPm.uo

LEXYACC = Scanner.sml Parser.sml Parser.sig Deplex.sml Deppars.sig Deppars.sml
LEXYACCSML = Scanner.sml Parser.sml Deplex.sml Deppars.sml

BINUTILS = convert gen_pm

.SUFFIXES :
.SUFFIXES : .sig .sml .ui .uo .grm .lex

.sig.ui:
	$(MOSMLC) $<

.sml.uo:
	$(MOSMLC) $<

.lex.sml:
	$(MOSMLLEX) $<

all: $(BINUTILS)

convert: $(CONVOBJS)
	$(MOSMLL) -standalone -o convert Convert.uo

gen_pm: $(GENPMOBJS)
	$(MOSMLL) -standalone -o gen_pm GenPm.uo


Parser.sml Parser.sig: Parser.grm
	$(MOSMLYACC) $<


Deppars.sml Deppars.sig: Deppars.grm
	$(MOSMLYACC) $<

clean:
	rm -f *.ui
	rm -f *.uo
	rm -f Makefile.bak
	rm -f $(LEXYACC)
	rm -f $(BINUTILS)

#install:
#	${INSTALL_DATA} convert $(TOOLDIR)

depend: $(LEXYACCSML)
	rm -f Makefile.bak
	mv Makefile Makefile.bak
	$(MOSMLTOOLS)/cutdeps < Makefile.bak > Makefile
	$(MOSMLTOOLS)/mosmldep >> Makefile

### DO NOT DELETE THIS LINE
Deppars.uo: Deppars.ui 
Deplex.uo: Deppars.ui 
Parser.uo: Parser.ui 
Scanner.uo: Parser.ui 
GenPm.uo: Deppars.ui Deplex.uo 
Convert.uo: Parser.ui Scanner.uo

=== debian/changelog ===
mosml (2.10.1-0ubuntu0) trusty; urgency=low

  * Initial release

 -- Ken Friis Larsen <ken@friislarsen.net>  Thu, 28 Aug 2014 07:41:21 +0000

=== debian/control ===
Source: mosml
Section: devel
Priority: optional
Maintainer: Ken Friis Larsen <ken@friislarsen.net>
Build-Depends: debhelper (>= 9), libgmp-dev
Standards-Version: 3.9.5
Homepage: http://mosml.org
Vcs-Git: git://github.com/kfl/mosml


Package: mosml
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmp10
Description: light-weight implementation of Standard ML (SML).
 Moscow ML:
   * implements the full Standard ML language, as revised 1997,
     including Modules and some extensions
   * yet is backwards compatible with Moscow ML versions prior to 2.00
   * implements large parts of the new SML Basis Library
   * implements separate compilation
   * can produce compact stand-alone executables (a la Caml Light)
   * supports quotations and antiquotations, useful for metaprogramming

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ -Dsrc

override_dh_auto_build:
	dh_auto_build -- PREFIX=/usr

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
